function varargout = GUI(varargin)

% GUI MATLAB code for GUI.fig
%      GUI, by itself, creates a new GUI or raises the existing
%      singleton*.
%
%      H = GUI returns the handle to a new GUI or the handle to
%      the existing singleton*.
%
%      GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI.M with the given input arguments.
%
%      GUI('Property','Value',...) creates a new GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before GUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help GUI

% Last Modified by GUIDE v2.5 16-May-2011 13:46:13

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before GUI is made visible.
function GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to GUI (see VARARGIN)

% Choose default command line output for GUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes GUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = GUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in push_seuil.
function push_seuil_Callback(hObject, eventdata, handles)
% hObject    handle to push_seuil (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    if (get(handles.push_seuil,'Value') == get(hObject,'Max'))
        frequency=20:100:20000; %cration du vecteur de frquences
        x=0.02:0.1:20; %vecteur des abscisses pour tracer la courbe
    
        s_aud=seuil_audible(frequency);
    
        figure(1)
        semilogx(x,s_aud,'LineWidth',1.5)
        xlabel('Frquences audibles (en Hz)');
        ylabel('Niveau de pression acoustique (en dB)');
        title('Courbe de Fletcher et Munson');
    end


    
function edit_bark_Callback(hObject, eventdata, handles)
% hObject    handle to edit_bark (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_bark as text
%        str2double(get(hObject,'String')) returns contents of edit_bark as a double
    freq=str2double(get(handles.edit_bark,'String'));
    setappdata(0,'freq',freq);

% --- Executes during object creation, after setting all properties.
function edit_bark_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_bark (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in push_bark.
function push_bark_Callback(hObject, eventdata, handles)
% hObject    handle to push_bark (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    if (get(handles.push_bark,'Value') == get(hObject,'Max'))
        freq=str2double(get(handles.edit_bark,'String'));
        setappdata(0,'freq',freq);
        
        if isnan(freq)
                set(handles.edit_bark,'String','2500');
                freq=str2double('2500');
        end
        
        freq_bark=bark(freq);
        
        if (freq_bark == 0)
            set(handles.text_freq_bark,'String','Frquence');
            set(handles.text_bark,'String','Incorrecte');
        else
            set(handles.text_freq_bark,'String',freq_bark);
            set(handles.text_bark,'String','Bark');
        end
        
        setappdata(0,'freq',freq);
    end


function edit_fech_waza_Callback(hObject, eventdata, handles)
% hObject    handle to edit_fech_waza (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_fech_waza as text
%        str2double(get(hObject,'String')) returns contents of edit_fech_waza as a double
    freq_ech=str2double(get(handles.edit_fech_waza,'String'));
    setappdata(0,'freq_ech',freq_ech);

% --- Executes during object creation, after setting all properties.
function edit_fech_waza_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_fech_waza (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in push_waza.
function push_waza_Callback(hObject, eventdata, handles)
% hObject    handle to push_waza (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    if (get(handles.push_waza,'Value') == get(hObject,'Max'))
        freq_ech=str2double(get(handles.edit_fech_waza,'String'));
        setappdata(0,'freq_ech',freq_ech);
        
        if isnan(freq_ech)
                set(handles.edit_fech_waza,'String','16000');
                freq_ech=str2double('16000');
        end
        
        
        waza(freq_ech)
        setappdata(0,'freq_ech',freq_ech);
    end


%**********************************************************************

% --- Executes on button press in radio_tf.
function radio_tf_Callback(hObject, eventdata, handles)
    if (get(handles.radio_tf,'Value') == get(hObject,'Max'))
        radiobuttons = findobj(gcbf, 'style', 'radio');
        set(radiobuttons, 'value', 0);
        set(handles.radio_tf, 'value', 1);
    else
        set(handles.radio_tf, 'value', 0);
    end


% --- Executes on button press in radio_sk.
function radio_sk_Callback(hObject, eventdata, handles)
    if (get(handles.radio_sk,'Value') == get(hObject,'Max'))
        radiobuttons = findobj(gcbf, 'style', 'radio');
        set(radiobuttons, 'value', 0);
        set(handles.radio_sk, 'value', 1);
    else
        set(handles.radio_sk, 'value', 0);
    end


% --- Executes on button press in radio_sk_critique.
function radio_sk_critique_Callback(hObject, eventdata, handles)
    if (get(handles.radio_sk_critique,'Value') == get(hObject,'Max'))
        radiobuttons = findobj(gcbf, 'style', 'radio');
        set(radiobuttons, 'value', 0);
        set(handles.radio_sk_critique, 'value', 1);
    else
        set(handles.radio_sk_critique, 'value', 0);
    end


% --- Executes on button press in radio_fenetre.
function radio_fenetre_Callback(hObject, eventdata, handles)
    if (get(handles.radio_fenetre,'Value') == get(hObject,'Max'))
        radiobuttons = findobj(gcbf, 'style', 'radio');
        set(radiobuttons, 'value', 0);
        set(handles.radio_fenetre, 'value', 1);
    else
        set(handles.radio_fenetre, 'value', 0);
    end


function edit_fenetre_Callback(hObject, eventdata, handles)
% hObject    handle to edit_fenetre (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



% --- Executes during object creation, after setting all properties.
function edit_fenetre_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_fenetre (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in push_s_k.
function push_s_k_Callback(hObject, eventdata, handles)


%***********************************************************************%
%     dfinition des abscisses et ordonnes des bandes critiques        %
%                                                                       %
bark_x=[20 100 200 300 400 510 630 770 920 1080 1270 1480 1720 2000 ... %
        2320 2700 3150 3700 4400 5300 6400 7700 9500 12000];            %
bark_y=[-20 100];                                                       %
%***********************************************************************%
    if (get(handles.push_s_k,'Value') == get(hObject,'Max'))
        fid=fopen('waziwaza.raw');
        s=fread(fid,'short');
        fe=16000;
        N=512;
        Nfft=512;

        x=1:512;
        x=(x-1)*fe/Nfft;
    
        sc=s(2100:2611);
        tfh_sn=abs(fft(sc.*hann(N)));
        
        %Variable globale ??
        %************ S(k) *************%
        s_k=10*log10(1/N.*tfh_sn.^2);   %
        %*******************************%

    if (get(handles.radio_tf,'Value') == get(hObject,'Max'))
        if (get(handles.push_s_k,'Value') == get(hObject,'Max'))
            axe=1:512;
            axe=(axe-1)*fe/Nfft;
            
            figure(3)
            
            plot(axe,tfh_sn)
            title('Trac de la transforme de Fourier du signal avec la porte Hann');
            xlabel('Frquence d''chantillonnage (en Hz)');
            ylabel('Pression acoustique (en dB)');
        end
    end
    
    if (get(handles.radio_sk,'Value') == get(hObject,'Max'))
        if (get(handles.push_s_k,'Value') == get(hObject,'Max'))
            figure(4)

            plot(x,s_k,'Color',[0 0 0])
            title('Trac du signal S(k)');
            xlabel('Frquence d''chantillonnage (en Hz)');
            ylabel('Pression acoustique (en dB)');
        end
    end
    
    if (get(handles.radio_sk_critique,'Value') == get(hObject,'Max'))
        if (get(handles.push_s_k,'Value') == get(hObject,'Max'))
            figure(5)
            
            plot(x,s_k,'Color',[1 0 0])
            
            for k=1:24
                line([bark_x(k) bark_x(k)], [bark_y(1) bark_y(2)],...
                     'LineStyle','-','Color',[0.7 0.8 0.9])
            end
            
            title('Trac du signal S(k) avec les bandes critiques minimales (f_B_a_r_k_ _m_i_n)');
            xlabel('Frquence d''chantillonnage (en Hz)');
            ylabel('Pression acoustique (en dB)');
        end
    end
            
    if (get(handles.radio_fenetre,'Value') == get(hObject,'Max'))
        if (get(handles.push_s_k,'Value') == get(hObject,'Max'))
            nbits=str2double(get(handles.edit_fenetre,'String'));
            setappdata(0,'nbits',nbits);

            if isnan(nbits)
                set(handles.edit_fenetre,'String','64');
                nbits=str2double('64');
            end

            wvtool(hamming(nbits),hann(nbits),gausswin(nbits))
            %hamming = vert / hann = bleu / gausswin = rouge
        end
    end
    end
    
    
%************************************************************************%
%***                            ETAPE 3                               ***%
%************************************************************************%

% --- Executes on button press in push_composante.
function push_composante_Callback(hObject, eventdata, handles)
% hObject    handle to push_composante (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


if (get(handles.push_composante,'Value') == get(hObject,'Max'))
        
    [coef_tona coef_ntona sig_sk]=GUI_mpeg_audio(s_k);
    for m=1:3
        freq_tona=sig_sk(coef_tona(m))
    end

     set(handles.text_freq_ton1,'String',freq_tona(1))
%     set(handles.text_freq_ton2,'String','92.0499'); %valeur freq_tona(1)
%     set(handles.text_freq_ton2,'String','87.8207'); %valeur freq_tona(2)
%     set(handles.text_freq_ton3,'String','70.5224'); %valeur freq_tona(3)
    

end 
