function s_k=tf_hann
clear all; clc; close all;

fid=fopen('waziwaza.raw');
s=fread(fid,'short');

fe=16000;
N=512;
Nfft=512;
sc=s(2100:2611);

tfh_sn=abs(fft(sc.*hann(N)));

axe=1:512;
axe=(axe-1)*fe/Nfft;
figure(1)
plot(axe,tfh_sn)
title('Trac de la transforme de Fourier du signal avec la porte Hann');
xlabel('Frquence d''chantillonnage (en Hz)');
ylabel('Amplitude');


s_k=10*log10(1/N.*tfh_sn.^2);

x=1:512;
x=(x-1)*fe/Nfft;

figure(2)
subplot(2,1,1)

hold on
plot(x,s_k,'Color',[0 0 0])
title('Trac du signal S(k)');
xlabel('Frquence d''chantillonnage (en Hz)');
ylabel('dB');

%***********************************************************************%
%     dfinition des abscisses et ordonnes des bandes critiques        %
%                                                                       %
bark_x=[20 100 200 300 400 510 630 770 920 1080 1270 1480 1720 2000 ... %
        2320 2700 3150 3700 4400 5300 6400 7700 9500 12000];            %
bark_y=[-20 100];                                                       %
%***********************************************************************%

subplot(2,1,2)
hold on
plot(x,s_k,'Color',[1 0 0])
for k=1:24
    line([bark_x(k) bark_x(k)], [bark_y(1) bark_y(2)], 'LineStyle','-','Color',[0.7 0.8 0.9])
end
title('Trac du signal S(k) avec les bandes critiques minimales (f_B_a_r_k_ _m_i_n)');
xlabel('Frquence d''chantillonnage (en Hz)');
ylabel('dB');