%------------------------------------------------------------- 
%Creation du GUI 
%------------------------------------------------------------- 
function GUIv2
%-------------------------------------------------------------
%Ouverture de la fenetre
%------------------------------------------------------------- 
figure('Name','[Projet Traitement du Signal] Codage MPEG',... 
                   'Units','pixels',...
                   'Position',[225 50 800 800],...
                   'Color',[.878 .875 .89],...
                   'menubar','none');

%-------------------------------------------------------------
%Creation du premier groupe de bouton :
%------------------------------------------------------------- 
psychoacoustic = uipanel('Title','Modle Psychoacoustique',...
                         'Units','normalized',...
                         'Clipping','off',...
                         'FontSize',10,...
                         'BackgroundColor',[.878 .875 .89],...
                         'Position',[.15 .78 .65 .2]);

%Bouton : Seuil Audible 
uicontrol('Parent',psychoacoustic,...
                      'pos',[.08 .4 .2 .3],...
                      'Units','normalized',...
                      'style','pushbutton',... 
                      'callback',@seuil_audible,... 
                      'String','Seuil Audible',...
                      'Tag','bouton_seuil');
                  
%Bouton : Frquence Bark 
uicontrol('Parent',psychoacoustic,...
                      'pos',[.4 .4 .2 .3],...
                      'Units','normalized',...
                      'style','pushbutton',... 
                      'callback',@freq_bark,... 
                      'String','Frquence Bark');
                  
%Champ parametrable de la frequence
uicontrol('Parent',psychoacoustic,...
                      'pos',[.4 .14 .2 .2],...
                      'Units','normalized',...
                      'style','edit',... 
                      'string','Frquence (Hz)',...
                      'BackgroundColor','white',...
                      'tag','freq2fbark');

%------------------------------------------------------
%Champ texte statique de la frequence de Bark
%
uicontrol('Parent',psychoacoustic,...
                      'pos',[.35 .8 .2 .1],...
                      'Units','normalized',...
                      'style','text',...
                      'BackgroundColor',[.878 .875 .89],...
                      'string','Frquence',...  
                      'tag','freq_bark');

uicontrol('Parent',psychoacoustic,...
                      'pos',[.53 .8 .08 .1],...
                      'Units','normalized',...
                      'style','text',... 
                      'BackgroundColor',[.878 .875 .89],...
                      'string','Bark',...  
                      'tag','unit_bark');
%--------------------------------------------------------

%Bouton : Lancer programme Waziwaza                   
uicontrol('Parent',psychoacoustic,...
                      'pos',[.73 .4 .2 .3],...
                      'Units','normalized',...
                      'style','pushbutton',... 
                      'callback',@waziwaza,... 
                      'String','Lancer Waziwaza');                 

%Champ parametrable de la frequence d'chantillonnage
uicontrol('Parent',psychoacoustic,...
                      'pos',[.725 .14 .21 .2],...
                      'Units','normalized',...
                      'style','edit',... 
                      'string','Frquence Ech. (Hz)',...
                      'BackgroundColor','white',...
                      'tag','freq_ech');

%-------------------------------------------------------------
% Calcul des courbes de masquage
%-------------------------------------------------------------
% Groupe de boutons :  
masquage = uipanel('Title','Calcul des courbes de masquage',...
                   'Clipping','off',...
                   'Units','normalized',...
                   'FontSize',10,...
                   'BackgroundColor',[.878 .875 .89],...
                   'Position',[.025 .15 0.95 .6]);

%------------------------------------------------------------- 
%Etape 1 et 2 : Calcul de S(k)
%------------------------------------------------------------- 
%Sous groupe :
etape12 = uipanel('Parent',masquage, 'Title','Etape 1 et 2',...
                  'FontSize',8.5,...
                  'Units','normalized',...
                  'BackgroundColor',[.878 .875 .89],...
                  'Position',[.025 .48 .47 .5]);

uicontrol('Parent',etape12,'pos',[.72 .42 .25 .2],...  
                      'style','pushbutton',...
                      'Units','normalized',...
                      'callback',@calcul_sk,... 
                      'String','Calculer S(k)');

%-------------------------------------------------------------
% Cration de uibuttongroup
selcourb = uibuttongroup('Parent',etape12,...
                         'Title','Slection des courbes',...
                         'FontSize',8,...
                         'Units','normalized',...
                         'BackgroundColor',[.878 .875 .89],...
                         'Position',[.035 .13 .65 .8]);


% Cration des 4 radiobuttons avec slection unique
uicontrol('Parent',selcourb,...
                        'Style','Radio',...
                        'Units','normalized',...
                        'String','TF{s(n)*w(n)}',...
                        'pos',[.1 .77 .4 .2],...
                        'BackgroundColor',[.878 .875 .89],...
                        'HandleVisibility','off','Tag','rbut1');

uicontrol('Parent',selcourb,...
                        'Style','Radio',...
                        'Units','normalized',...
                        'String','Courbe de S(k)',...
                        'pos',[.1 .58 .5 .2],...
                        'BackgroundColor',[.878 .875 .89],...
                        'HandleVisibility','off','Tag','rbut2');

uicontrol('Parent',selcourb,...
                        'Style','Radio',...
                        'Units','normalized',...
                        'String','Courbe de S(k) + bandes critiques',...
                        'pos',[.1 .39 .9 .2],...
                        'BackgroundColor',[.878 .875 .89],...
                        'HandleVisibility','off','Tag','rbut3');

uicontrol('Parent',selcourb,...
                        'Style','Radio',...
                        'Units','normalized',...
                        'String','Courbes de Hann, Hamming, Gauss',...
                        'pos',[.1 .2 .9 .2],...
                        'BackgroundColor',[.878 .875 .89],...
                        'HandleVisibility','off','Tag','rbut4');            

%---------------------------------------------------------------------
% Initialize some button group properties.
set(selcourb,'SelectionChangeFcn');
set(selcourb,'SelectedObject',[]);  % No selection
set(selcourb,'Visible','on');
%---------------------------------------------------------------------

uicontrol('Parent',selcourb,...
                        'Style','edit',...
                        'Units','normalized',...
                        'String','Entrez une valeur de N bits',...
                        'pos',[.24 .07 .6 .15],...
                        'BackgroundColor','white',...
                        'Tag','editbit');

%------------------------------------------------------------- 
%Etape 3 : Appel fonction mpeg_audio
%------------------------------------------------------------- 
%Sous groupe :
etape3 = uipanel('Parent',masquage, 'Title','Etape 3',...
                  'FontSize',8.5,...
                  'Units','normalized',...
                  'BackgroundColor',[.878 .875 .89],...
                  'Position',[.54 .48 .45 .5]);

% cration du bouton calcul des composantes de s(k)
uicontrol('Parent',etape3,...
                       'Style','PushButton',...
                       'Units','normalized',...
                       'String','Composantes S(k)',...
                       'pos',[.05 .7 .32 .2],...
                       'Callback',@compo_signal);

uicontrol('Parent',etape3,...
                       'Style','text',...
                       'Units','normalized',...
                       'String','Frquence Tonale 1 :',...
                       'BackgroundColor',[.878 .875 .89],...
                       'pos',[.38 .85 .4 .1]);

                   
uicontrol('Parent',etape3,...
                       'Style','text',...
                       'Units','normalized',...
                       'String','Frquence Tonale 2 :',...
                       'BackgroundColor',[.878 .875 .89],...
                       'pos',[.38 .75 .4 .1]);


uicontrol('Parent',etape3,...
                       'Style','text',...
                       'Units','normalized',...
                       'String','Frquence Tonale 3 :',...
                       'BackgroundColor',[.878 .875 .89],...
                       'pos',[.38 .65 .4 .1]);
                   
%------------------------------------------------------------------
% texte statique qui affiche les 3 frquences tonales
%------------------------------------------------------------------
uicontrol('Parent',etape3,...
                       'Style','text',...
                       'Units','normalized',...
                       'String','none',...
                       'BackgroundColor',[.878 .875 .89],...
                       'pos',[.74 .85 .15 .1],...
                       'tag','tonale1');
                   
uicontrol('Parent',etape3,...
                       'Style','text',...
                       'Units','normalized',...
                       'String','none',...
                       'BackgroundColor',[.878 .875 .89],...
                       'pos',[.74 .75 .15 .1],...
                       'tag','tonale2');
                  
uicontrol('Parent',etape3,...
                       'Style','text',...
                       'Units','normalized',...
                       'String','none',...
                       'BackgroundColor',[.878 .875 .89],...
                       'pos',[.74 .65 .15 .1],...
                       'tag','tonale3');
%-------------------------------------------------------------------                    
                   
uicontrol('Parent',etape3,...
                       'Style','text',...
                       'Units','normalized',...
                       'String','Hz',...
                       'BackgroundColor',[.878 .875 .89],...
                       'pos',[.88 .85 .1 .1]);
                   
uicontrol('Parent',etape3,...
                       'Style','text',...
                       'Units','normalized',...
                       'String','Hz',...
                       'BackgroundColor',[.878 .875 .89],...
                       'pos',[.88 .75 .1 .1]);

uicontrol('Parent',etape3,...
                       'Style','text',...
                       'Units','normalized',...
                       'String','Hz',...
                       'BackgroundColor',[.878 .875 .89],...
                       'pos',[.88 .65 .1 .1]);


%------------------------------------------------------------- 
data=guihandles(gcf); %structure des identifiants graphiques = Tag
guidata(gcf,data) %stockage data objet figure
%------------------------------------------------------------- 
%Fin : Creation du GUI 
%------------------------------------------------------------- 

function seuil_audible(obj,event)

data=guidata(gcbf);

    if (get(data.bouton_seuil,'Value') == get(obj,'Max'))
        frequency=20:100:20000; %cration du vecteur de frquences
        x=0.02:0.1:20; %vecteur des abscisses pour tracer la courbe
    
        s_aud=seuil_audible(frequency);
    
        figure
        semilogx(x,s_aud,'LineWidth',1.5)
        xlabel('Frquences audibles (en Hz)');
        ylabel('Niveau de pression acoustique (en dB)');
        title('Courbe de Fletcher et Munson');
    end
